/*
 * abasic
 * Copyright (C) 2007 m_inaba
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "./variant.h"


VARIANT_ pos;

VARIANT_::VARIANT_(){
	VARIANT_::init();
}

VARIANT_::~VARIANT_(){
}

void VARIANT_::init(){
	*(VARIANT_::str_val)='\0';
	VARIANT_::d_val=0;
	VARIANT_::flag=TYPE_VAL;//l͒l^
}

//---------------------------------------
void VARIANT_::operator=(char*obj){
	VARIANT_::init();
	VARIANT_::flag=TYPE_VAL;//l^ɐݒ

	char*ptr=obj;
	int flag=-1;
	if('+'==*ptr || '-'==*ptr) ptr++;

	while(*ptr){
		if('.'==*ptr){
			flag++;
			if(0<flag){
				//Ȃ
				VARIANT_::flag=TYPE_STR;//^ɐݒ
				break;
			}
		}else if('0'>*ptr || '9'<*ptr){
			//Ȃ
			VARIANT_::flag=TYPE_STR;//^ɐݒ
			break;
		}
		ptr++;
	}

	if(TYPE_VAL==VARIANT_::flag){
		VARIANT_::d_val=atof(obj);//lɕϊ
	}else{
		_strcpy(VARIANT_::str_val,obj);
	}
}

void VARIANT_::operator=(VARIANT_*obj){
	VARIANT_::init();
	VARIANT_::flag=obj->flag;//^Rs[
	if(TYPE_VAL==VARIANT_::flag){
		VARIANT_::d_val   = obj->d_val;
	}else{
		_strcpy(VARIANT_::str_val,obj->str_val);
	}
}

void VARIANT_::operator=(int obj){
	VARIANT_::init();
	VARIANT_::d_val   = (double)obj;
	VARIANT_::flag=TYPE_VAL;//l^ɐݒ
}

//---------------------------------------
VARIANT_*VARIANT_::operator+(VARIANT_*obj){
	pos.init();
	//ǂ炩̏ꍇɂ͕ɂ
	if(TYPE_STR==flag || TYPE_STR==obj->flag){
		pos.flag=TYPE_STR;
	}else{
		pos.flag=TYPE_VAL;
	}

	if(TYPE_VAL==pos.flag){
		//l{l
		pos.d_val = VARIANT_::d_val+obj->d_val;
	}else if(TYPE_VAL==flag && TYPE_STR==obj->flag){
		//l{
		if('\"'==*(obj->str_val)){//̐擪"폜
			sprintf(pos.str_val,"\"%g",VARIANT_::d_val);
			strcat(pos.str_val,&(obj->str_val[1]));
		}else{
			sprintf(pos.str_val,"\"%g",VARIANT_::d_val);
			strcat(pos.str_val,&(obj->str_val[0]));
		}
	}else if(TYPE_STR==flag && TYPE_VAL==obj->flag){
		//{l
		_strcpy(pos.str_val,VARIANT_::str_val);
		sprintf(str_buf12,"%g",obj->d_val);
		strcat(pos.str_val,str_buf12);
	}else{
		//{
		if('\"'==*(obj->str_val)){//̐擪"폜
			_strcpy(pos.str_val,VARIANT_::str_val);
			strcat(pos.str_val,&(obj->str_val[1]));
		}else{
			_strcpy(pos.str_val,VARIANT_::str_val);
			strcat(pos.str_val,&(obj->str_val[0]));
		}
	}
	return &pos;
}

//---------------------------------------
VARIANT_*VARIANT_::operator-(VARIANT_*obj){
	pos.init();
	pos.d_val = VARIANT_::d_val-obj->d_val;
	pos.flag = TYPE_VAL;//l^ɐݒ
	return &pos;
}

//---------------------------------------
VARIANT_*VARIANT_::operator*(VARIANT_*obj){
	pos.init();
	pos.d_val =VARIANT_::d_val*obj->d_val;
	pos.flag = TYPE_VAL;//l^ɐݒ
	return &pos;
}

//---------------------------------------
VARIANT_*VARIANT_::operator/(VARIANT_*obj){
	pos.init();
	pos.d_val =VARIANT_::d_val/obj->d_val;
	pos.flag = TYPE_VAL;//l^ɐݒ
	return &pos;
}

//---------------------------------------
VARIANT_*VARIANT_::operator^(VARIANT_*obj){
	pos.init();
	pos.d_val =pow(VARIANT_::d_val,obj->d_val);
	pos.flag = TYPE_VAL;//l^ɐݒ
	return &pos;
}
//---------------------------------------
VARIANT_*VARIANT_::operator%(VARIANT_*obj){
	pos.init();
	pos.d_val =fmod(VARIANT_::d_val,obj->d_val);
	pos.flag = TYPE_VAL;//l^ɐݒ
	return &pos;
}
//---------------------------------------
VARIANT_*VARIANT_::operator==(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		//ӂl
		pos=VARIANT_::d_val==obj->d_val;
		return &pos;
	}else if(TYPE_STR==obj->flag && TYPE_STR==flag){
		//ӂ
		pos=!strcmp(VARIANT_::str_val,obj->str_val);
		return &pos;
	}else{
		//ȊO͑0Ԃ
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator<(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		pos=VARIANT_::d_val<obj->d_val;
		return &pos;
	}else{
		pos=0;
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator>(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		pos=VARIANT_::d_val>obj->d_val;
		return &pos;
	}else{
		pos=0;
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator<=(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		pos=VARIANT_::d_val<=obj->d_val;
		return &pos;
	}else{
		pos=0;
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator>=(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		pos=VARIANT_::d_val>=obj->d_val;
		return &pos;
	}else{
		pos=0;
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator!=(VARIANT_*obj){
	pos.init();
	if(TYPE_VAL==obj->flag && TYPE_VAL==flag){
		pos=VARIANT_::d_val!=obj->d_val;
		return &pos;
	}else{
		pos=strcmp(VARIANT_::str_val,obj->str_val);
		return &pos;
	}
}

//---------------------------------------
VARIANT_*VARIANT_::operator&&(VARIANT_*obj){
	pos.init();
	pos=VARIANT_::d_val&&obj->d_val;
	return &pos;
}
//---------------------------------------
VARIANT_*VARIANT_::operator&(VARIANT_*obj){
	pos.init();
	pos=(long)(VARIANT_::d_val)&(long)(obj->d_val);
	return &pos;
}
//---------------------------------------
VARIANT_*VARIANT_::operator||(VARIANT_*obj){
	pos.init();
	pos=VARIANT_::d_val||obj->d_val;
	return &pos;
}
//---------------------------------------
VARIANT_*VARIANT_::operator|(VARIANT_*obj){
	pos.init();
	pos=(long)(VARIANT_::d_val)|(long)(obj->d_val);
	return &pos;
}
//-------------------------------------------------------------------------------
